// textures for IceCastle

#version unofficial MegaPov 0.6;  

#include "kolors.inc"
#include "metals.inc"      
#include "woods.inc"   

#declare T_Mountain = 
 texture {
  pigment {
    granite
    color_map {
      [0.000 rgb 0.9577 ]//<0.996, 0.969, 0.8>]
      [0.154 rgb 0.7663 ]//<0.996, 0.682, 0.604>]
      [0.308 rgb 0.8334 ]//<0.906, 0.82, 0.714>]
      [0.444 rgb 0.6752 ]//<0.816, 0.631, 0.537>]
      [0.615 rgb 0.8077 ]//<0.89, 0.792, 0.675>]
      [0.812 rgb 0.7297 ]//<0.973, 0.627, 0.627>]
      [1.000 rgb 0.9577 ]//<0.996, 0.969, 0.8>]
    }
    turbulence 0.6
    ramp_wave
    scale <200.0, 3.0, 150.0>
    rotate -5.0 * z
  }
  normal {
    bozo , 5.0
    bump_size 0.8
    turbulence 0.7
    ramp_wave
    rotate -90.0 * x
  }
 }
 texture {
  pigment {
    granite
    color_map {
      [0.000 rgb 0.016 ] // <0.027, 0.012, 0.012>]
      [0.034 rgbf  <0.815,0.815,0.815,0.235>] // <0.851, 0.812, 0.741, 0.235>]
      [0.342 rgbf  <0.713,0.713,0.713,0.839>] // <0.71164, 0.694, 0.82, 0.839>]
      [0.462 rgbf  <0.539,0.539,0.539,0.608>] // <0.631, 0.506, 0.471, 0.608>]
      [0.632 rgbf  <0.815,0.815,0.915,0.922>] // <0.851, 0.812, 0.741, 0.922>]
      [0.983 rgb 0.016 ] // <0.027, 0.012, 0.012>]
      [1.000 rgb 0.957 ] // <0.996, 0.969, 0.8>]
    }
    turbulence 0.6
    ramp_wave
    scale <150.0, 3.0, 200.0>
    rotate <5.0, -10.0, 0.0>
  }
  normal {
    bozo , 5.0
    bump_size 0.8
    turbulence 0.8
    ramp_wave
    rotate -90.0 * x
  }
 }
 texture {
  pigment {
    granite
    color_map {
      [0.000 rgbf <0.0, 0.0, 0.0, 0.6>]
      [0.040 rgbf <0.0, 0.0, 0.0, 1.0>]
      [0.041 rgbf <0.227,0.227,0.227,0.8>] // <0.55, 0.09, 0.09, 0.8>]
      [0.970 rgbf <0.33, 0.33, 0.33, 0.9>]
      [0.971 rgbf <0.0, 0.0, 0.0, 0.9>]
      [1.000 rgbf <0.0, 0.0, 0.0, 1.0>]
    }
    turbulence 0.85
    ramp_wave
    scale <1.0, 2.0, 1.4>
    rotate <-10.0, 0.0, 20.0>
  }
 }

#if (SlowTexture=0)
 #declare T_Ice=
  texture {
   pigment {rgbf <0.9,0.9,1,0.1>}
   finish {ambient 0.15 diffuse 0.7 }//reflection 0.05 specular 0.7 roughness 0.001}
  }         
  
 #declare I_Ice=
  interior {}
#else
 #declare T_Ice = 
  texture { 
   pigment {rgbf <0.9,0.9,1,0.4>}
   finish { 
    ambient 0.15 diffuse 0.65 specular 0.5 reflection 0.2 
   }
   normal { 
    bumps 0.25 scale 0.5 
   }
   scale .1
  }
 #declare I_Ice = 
  interior {
   ior 1.309   //  ICE 
   media {  
    emission <0.1,0.1,0.15>*8
    absorption <0.1,0.1,0.15>*6.9
    method 3 
    density {
     rgb 1
    }                    
   }
  }
#end

#declare Metal=
 texture {
  T_Silver_4D
 }
   
#declare M_Bridge=
 material {
  texture {
   pigment {rgbf <0.965,0.965,1,0.95>}
   finish {
    specular 0.7 
    roughness 0.002 
    reflection 0.5
    //ambient 0 diffuse 0
    //irid {0.1 thickness 0.15}
   }
  }
  interior {//ior 1.1
   /*media {
    emission 5
    absorption 0.4
    method 3
    density {
     cylindrical
     color_map {
      [0.000 rgb 0]
      [0.005 rgb 10]
      [0.020 rgb 10]
      [0.025 rgb 0]
     }
     rotate z*-90
    }     
   }*/
  }
  //scale 63.6  
 }  
 
#declare T_Snow=      
 texture {
  pigment {rgb <0.95,0.95,1>}
  finish {
   ambient 0.3
   diffuse 0.6
   reflection_type 1
   reflection_min 0
   reflection_max 0.4
   specular 0.6 roughness 0.008
  }
 }
 
#declare T_Snow1 =
 texture {
  pigment { color rgb 1 }
  normal { bozo .75 turbulence .5 }
  finish { 
   ambient 0.1
   diffuse 0.539567
   brilliance 0.977333
   phong 0.2446
   phong_size 31.786667
   specular 0.165467
   roughness 0.466133
  }
 }
 
#declare T_Snow2 = 
texture {
   pigment { rgb 1 }   
   finish {             
      ambient 0.15
      diffuse 0.6 
      specular 0.3              
      roughness 0.6             
      brilliance 0.4
   }
}         

#declare Material1_texture =
 texture {
    pigment { image_map {png "posertex3.png" } }
 }

#declare Material2_texture =
texture {
   pigment {DarkBrown}
   normal {granite 0.1 scale 0.5}
}
